// verifica se una lista di interi
// è ordinata

@scala.annotation.tailrec
def isSorted(l:List[Int]):Boolean = {
	if (l.size<2) true
	else if (l.head > l.tail.head) false
		else isSorted(l.tail)
}

// scriviamo la nostra versione ricorsiva
// del metodo map delle liste
def myMap[A,B](l:List[A],f:A=>B):List[B] = {
	if (l.size<1) Nil
	else f(l.head) :: myMap(l.tail, f)
}

// verifica se una lista a è sottolista di
// un'altra lista b
// Esempio: a = List(2,3) e b = List(1,2,3,4)
def sottolista[T](a:List[T],b:List[T]):Boolean = {
	if (a.size > b.size) false
	else b.slice(0,a.size)==a || sottolista(a,b.tail)
}

// calcolo del fattoriare usando i metodi delle liste
def myFact(n:Int):Int = {
	List.range(1,n+1).reduce(_*_)
}

// calcolo della somma dei primi n numeri usando
// i metodi sulle liste
def somma(n:Int):Int =
	(1 to n).reduce(_+_)

// data lista elementi, trova gli indici di uno
// specifico elemento x
// Esempio: se List(1,2,1,1,3) e x=1 allora l'output
// deve essere List(0,2,3)
def trovaIndici[T](l:List[T], x:T):List[Int] = {
	l.zipWithIndex.filter(_._1 == x).map(_._2)
}

// metodo di fusione di due liste ordinate
def merge(a:List[Int],b:List[Int]):List[Int] = {
	if (a.isEmpty) b
	else if (b.isEmpty) a
	else if (a.head < b.head) a.head :: merge(a.tail,b)
	else b.head :: merge(a,b.tail)
}

def mergeSort(l:List[Int]):List[Int] = {
	if (l.size<2) l
	else {
		val (l1,l2) = l.splitAt(l.size/2)
		val a = mergeSort(l1)
		val b = mergeSort(l2)
		merge(a,b)
	}
}

def quickSort(l:List[Int]):List[Int] = {
	if (l.isEmpty) l
	else {
		val sx = l.filter(_<l.head)
		val dx = l.filter(_>=l.head).tail
		quickSort(sx) ::: (l.head :: quickSort(dx))
	}
}
